using System;
using System.Runtime.InteropServices;

namespace RobotArm
{
    class Program
    {
        static void Main(string[] args)
        {
            //Assign Port Number - Remember to change this to match your Robot Arm port number
            byte PortNumber = 63;
            byte hasObj;

            //Open Port
            RA_DLL.RA_ComOpen(PortNumber);

            //Delay to allow Comms to be estabished
            System.Threading.Thread.Sleep(10000);

            //Store Coordinates
            RA_DLL.RA_StoreCoords(PortNumber, 0, 167, 14, 54, 90, 31);
            RA_DLL.RA_StoreCoords(PortNumber, 1, 167, 0, 59, 90, 31);
            RA_DLL.RA_StoreCoords(PortNumber, 2, 17, 14, 54, 90, 31);
            RA_DLL.RA_StoreCoords(PortNumber, 3, 17, 0, 59, 90, 31);

            //Goto Position A and pick up object
            RA_DLL.RA_GotoPosition(PortNumber, 0);
            RA_DLL.RA_GripperOpen(PortNumber);
            RA_DLL.RA_GotoPosition(PortNumber, 1);
            hasObj = RA_DLL.RA_GripperClose(PortNumber, 50);
            RA_DLL.RA_GotoPosition(PortNumber, 0);

            //If we have an object then take to position B
            if (hasObj == 1)
            {
                RA_DLL.RA_GotoPosition(PortNumber, 2);
                RA_DLL.RA_GotoPosition(PortNumber, 3);
                RA_DLL.RA_GripperOpen(PortNumber);
                RA_DLL.RA_GotoPosition(PortNumber, 2);
            }

            //Remember to park the arm when done.
            RA_DLL.RA_Park(PortNumber);
            System.Threading.Thread.Sleep(2000);

            //Goto Position B and pick up object
            RA_DLL.RA_GotoPosition(PortNumber, 2);
            RA_DLL.RA_GripperOpen(PortNumber);
            RA_DLL.RA_GotoPosition(PortNumber, 3);
            hasObj = RA_DLL.RA_GripperClose(PortNumber, 50);
            RA_DLL.RA_GotoPosition(PortNumber, 2);

            //If we have an object then take to position A
            if (hasObj == 1)
            {
                RA_DLL.RA_GotoPosition(PortNumber, 0);
                RA_DLL.RA_GotoPosition(PortNumber, 1);
                RA_DLL.RA_GripperOpen(PortNumber);
                RA_DLL.RA_GotoPosition(PortNumber, 0);
            }

            //Remember to park the arm when done.
            RA_DLL.RA_Park(PortNumber);

            //Close Port
            RA_DLL.RA_ComClose(PortNumber);
        }
    }
}


