﻿using System.Runtime.InteropServices;

namespace RobotArm
{
    class RA_DLL
    {
        [DllImport("RobotArm.dll")]
        public static extern byte RA_ComOpen(byte Port);
        [DllImport("RobotArm.dll")]
        public static extern byte RA_ComClose(byte Port);
        [DllImport("RobotArm.dll")]
        public static extern byte RA_GetAPIVersion(byte Port);

        [DllImport("RobotArm.dll")]
        public static extern void RA_LEDWrite(byte Port, byte value);
        [DllImport("RobotArm.dll")]
        public static extern void RA_LEDOn(byte Port, byte index);
        [DllImport("RobotArm.dll")]
        public static extern void RA_LEDOff(byte Port, byte index);

        [DllImport("RobotArm.dll")]
        public static extern byte RA_SetServo(byte Port, byte index, byte position);
        [DllImport("RobotArm.dll")]
        public static extern byte RA_SetAllServos(byte Port, byte position0, byte position1, byte position2, byte position3, byte position4);
        [DllImport("RobotArm.dll")]
        public static extern byte RA_GripperClose(byte Port, byte strength);
        [DllImport("RobotArm.dll")]
        public static extern byte RA_GripperOpen(byte Port);
        [DllImport("RobotArm.dll")]
        public static extern byte RA_Park(byte Port);
        [DllImport("RobotArm.dll")]
        public static extern void RA_StoreCoords(byte Port, byte index, byte position0, byte position1, byte position2, byte position3, byte position4);
        [DllImport("RobotArm.dll")]
        public static extern void RA_StorePosition(byte Port, byte index);
        [DllImport("RobotArm.dll")]
        public static extern byte RA_GotoPosition(byte Port, byte index);

        [DllImport("RobotArm.dll")]
        public static extern byte RA_ReadSwitch(byte Port, byte index);
        [DllImport("RobotArm.dll")]
        public static extern byte RA_ReadLight(byte Port);
        [DllImport("RobotArm.dll")]
        public static extern byte RA_ReadPot(byte Port);
        [DllImport("RobotArm.dll")]
        public static extern byte RA_ReadPressure(byte Port);
        [DllImport("RobotArm.dll")]
        public static extern byte RA_ReadMagnet(byte Port);
        [DllImport("RobotArm.dll")]
        public static extern int RA_ReadColour(byte Port);
        [DllImport("RobotArm.dll")]
        public static extern byte RA_ReadColourChannel(byte Port, byte index, int colour);

        [DllImport("RobotArm.dll")]
        public static extern void RA_LCDClear(byte Port);
        [DllImport("RobotArm.dll")]
        public static extern void RA_LCDPrint(byte Port, byte[] text); 
        [DllImport("RobotArm.dll")]
        public static extern void RA_LCDNumber(byte Port, int number);
        [DllImport("RobotArm.dll")]
        public static extern void RA_LCDCursor(byte Port, byte x, byte y);
        [DllImport("RobotArm.dll")]
        public static extern void RA_LCDClearLine(byte Port, byte line);
 


        //String Functions with conversions
        public static void RA_LCDPrintString(byte Port, string text)
        {
            RA_LCDPrint(Port, System.Text.Encoding.UTF8.GetBytes(text));
        }


    }
}
